diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/vpsfs/vpsfs.h head/sys/fs/vpsfs/vpsfs.h
--- clean-head/sys/fs/vpsfs/vpsfs.h	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/fs/vpsfs/vpsfs.h	2013-06-24 14:20:41.000000000 +0200
@@ -0,0 +1,134 @@
+/*-
+ * Copyright (c) 1992, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * This code is derived from software donated to Berkeley by
+ * Jan-Simon Pendry.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)vpsfs.h	8.3 (Berkeley) 8/20/94
+ *
+ * $FreeBSD: head/sys/fs/vpsfsfs/vpsfs.h 250505 2013-05-11 11:17:44Z kib $
+ */
+
+#ifndef	FS_VPSFS_H
+#define	FS_VPSFS_H
+
+/* based on fs/nullfs r250505 */
+
+/*
+#define VPSFS_DEBUG
+*/
+
+#define	VPSFSM_CACHE	0x0001
+
+struct vpsfs_limits;
+
+struct vpsfs_mount {
+	struct mount	*vpsfsm_vfs;
+	struct vnode	*vpsfsm_rootvp;	/* Reference to root vpsfs_node */
+	uint64_t	vpsfsm_flags;
+	struct vpsfs_limits *vpsfsm_limits;
+	int	     limits_last_sync;
+	struct task	limits_sync_task;
+	char		limits_sync_task_enqueued;
+	struct mtx	vpsfs_mtx;
+};
+
+#ifdef _KERNEL
+/*
+ * A cache of vnode references
+ */
+struct vpsfs_node {
+	LIST_ENTRY(vpsfs_node)	vpsfs_hash;	/* Hash list */
+	struct vnode		*vpsfs_lowervp;	/* VREFed once */
+	struct vnode		*vpsfs_vnode;	/* Back pointer */
+	u_int			vpsfs_flags;
+};
+
+struct vpsfs_limits {
+	size_t space_used;
+	size_t nodes_used;
+	size_t space_soft;
+	size_t nodes_soft;
+	size_t space_hard;
+	size_t nodes_hard;
+};	  
+
+#define	VPSFSV_NOUNLOCK		0x0001
+#define	VPSFSV_DROP		0x0002
+#define VPSFSV_FORBIDDEN	0x0003
+
+#define	MOUNTTOVPSFSMOUNT(mp) ((struct vpsfs_mount *)((mp)->mnt_data))
+#define	VTOVPSFS(vp) ((struct vpsfs_node *)(vp)->v_data)
+#define	VPSFSTOV(xp) ((xp)->vpsfs_vnode)
+
+int vpsfs_init(struct vfsconf *vfsp);
+int vpsfs_uninit(struct vfsconf *vfsp);
+int vpsfs_nodeget(struct mount *mp, struct vnode *target,
+    struct vnode **vpp);
+struct vnode *vpsfs_hashget(struct mount *mp, struct vnode *lowervp);
+void vpsfs_hashrem(struct vpsfs_node *xp);
+int vpsfs_bypass(struct vop_generic_args *ap);
+
+int vpsfs_calcusage(struct vpsfs_mount *, struct vpsfs_limits *);
+int vpsfs_calcusage_path(const char *, struct vpsfs_limits *);
+int vpsfs_mount_is_vpsfs(struct mount *mp);
+int vpsfs_read_usage(struct vpsfs_mount *mount,
+    struct vpsfs_limits *limits);
+int vpsfs_write_usage(struct vpsfs_mount *mount,
+    struct vpsfs_limits *limits);
+int vpsfs_limit_alloc(struct vpsfs_mount *mount, size_t space,
+    size_t nodes);
+int vpsfs_limit_free(struct vpsfs_mount *mount, size_t space,
+    size_t nodes);
+
+#ifdef DIAGNOSTIC
+struct vnode *vpsfs_checkvp(struct vnode *vp, char *fil, int lno);
+#define	VPSFSVPTOLOWERVP(vp) vpsfs_checkvp((vp), __FILE__, __LINE__)
+#else
+#define	VPSFSVPTOLOWERVP(vp) (VTOVPSFS(vp)->vpsfs_lowervp)
+#endif
+
+extern struct vop_vector vpsfs_vnodeops;
+
+/*
+extern int (*vpsfs_calcusage_path_p)(const char *, struct vpsfs_limits *);
+*/
+
+#ifdef MALLOC_DECLARE
+MALLOC_DECLARE(M_VPSFSNODE);
+#endif
+
+#ifdef VPSFS_DEBUG
+#define VPSFSDEBUG(format, args...) printf(format ,## args)
+#else
+#define VPSFSDEBUG(format, args...)
+#endif /* VPSFS_DEBUG */
+
+#endif /* _KERNEL */
+
+#endif
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/vpsfs/vpsfs_quota.c head/sys/fs/vpsfs/vpsfs_quota.c
--- clean-head/sys/fs/vpsfs/vpsfs_quota.c	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/fs/vpsfs/vpsfs_quota.c	2013-06-24 14:20:41.000000000 +0200
@@ -0,0 +1,672 @@
+/*-
+ * Copyright (c) 2009-2013 Klaus P. Ohrhallinger <k@7he.at>
+ * All rights reserved.
+ *
+ * Development of this software was partly funded by:
+ *    TransIP.nl <http://www.transip.nl/>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+static const char vpsid[] =
+    "$Id: vpsfs_quota.c 178 2013-06-13 10:36:51Z klaus $";
+
+
+#include "opt_global.h"
+
+#ifdef VPS
+
+#include <sys/cdefs.h>
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/kernel.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/malloc.h>
+#include <sys/mount.h>
+#include <sys/proc.h>
+#include <sys/vnode.h>
+#include <sys/dirent.h>
+#include <sys/namei.h>
+#include <sys/fcntl.h>
+#include <sys/stat.h>
+#include <sys/proc.h>
+#include <sys/filedesc.h>
+#include <sys/taskqueue.h>
+
+#include <security/audit/audit.h>
+#include <security/mac/mac_framework.h>
+
+#include <fs/vpsfs/vpsfs.h>
+
+int vn_fullpath1(struct thread *td, struct vnode *vp, struct vnode *rdir,
+    char *buf, char **retbuf, u_int buflen);
+
+#define DIRENT_MINSIZE (sizeof(struct dirent) - (MAXNAMLEN+1) + 4)
+
+static int vpsfs_readdir(struct thread *td, struct vnode *vp,
+    int dirbuflen, struct vpsfs_limits *,
+    void (*cbfunc)(struct vnode *, struct vpsfs_limits *, struct thread *));
+
+static int get_next_dirent(struct vnode *vp, struct dirent **dpp,
+    char *dirbuf, int dirbuflen, off_t *off, char **cpos, int *len,
+    int *eofflag, struct thread *td);
+
+static void vpsfs_calcvnode(struct vnode *vp, struct vpsfs_limits *limits,
+    struct thread *td);
+
+/*
+ *
+ * Read a file with quota information from disk when mounting.
+ * XXX Hide this quota file in upper layer.
+ * Keep information from file up to date with all allocations/removals
+ * and sync to disk every now and then.
+ * Recalculate and write file to disk on request (ioctl).
+ *
+ */
+
+static void
+vpsfs_sync_task(void *context, int pending)
+{
+	struct vpsfs_mount *mount;
+
+	mount = (struct vpsfs_mount *)context;
+
+	mtx_lock(&mount->vpsfs_mtx);
+	mount->limits_sync_task_enqueued = 0;
+	mtx_unlock(&mount->vpsfs_mtx);
+
+	if (vpsfs_write_usage(mount, mount->vpsfsm_limits) != 0)
+		printf("%s: WARNING: couldn't sync!\n", __func__);
+
+	mount->limits_last_sync = ticks;
+}
+
+static void
+vpsfs_sched_sync(struct vpsfs_mount *mount)
+{
+
+	mtx_lock(&mount->vpsfs_mtx);
+	if (!mount->limits_sync_task_enqueued &&
+	    (ticks - mount->limits_last_sync) > (hz * 60)) {
+		VPSFSDEBUG("%s: ticks=%u mount->limits_last_sync=%u "
+		    "hz=%u\n", __func__, ticks, mount->limits_last_sync,
+		    hz);
+		TASK_INIT(&mount->limits_sync_task, 0, vpsfs_sync_task,
+		    mount);
+		taskqueue_enqueue(taskqueue_thread,
+		    &mount->limits_sync_task);
+		mount->limits_sync_task_enqueued = 1;
+	}
+	mtx_unlock(&mount->vpsfs_mtx);
+}
+
+int
+vpsfs_limit_alloc(struct vpsfs_mount *mount, size_t space, size_t nodes)
+{
+	struct vpsfs_limits *lp;
+	int rs, rn;
+	int warn;
+	int error;
+
+	lp = mount->vpsfsm_limits;
+
+	/* XXX lock */
+	if (lp->space_hard != 0 && (lp->space_used + space >
+	    lp->space_hard))
+		/* hard */
+		rs = 2;
+	else if (lp->space_soft != 0 && (lp->space_used + space >
+	    lp->space_soft))
+		/* soft */
+		rs = 1;
+	else
+		/* fine */
+		rs = 0;
+
+	if (lp->nodes_hard != 0 && (lp->nodes_used + nodes >
+	    lp->nodes_hard))
+		/* hard */
+		rn = 2;
+	else if (lp->nodes_soft != 0 && (lp->nodes_used + nodes >
+	    lp->nodes_soft))
+		/* soft */
+		rn = 1;
+	else
+		/* fine */
+		rn = 0;
+
+	error = warn = 0;
+	if (rs == 0 && rn == 0)
+		/* fine */
+		;
+	else if (rs <= 1 && rn <= 1)
+		/* warning */
+		warn = 1;
+	else
+		/* deny */
+		error = ENOSPC;
+
+	if (warn)
+		VPSFSDEBUG("%s: WARNING: hit soft limit !\n", __func__);
+
+	if (error == 0) {
+		VPSFSDEBUG("%s: space_used: %zu -> %zu    "
+		    "nodes_used: %zu -> %zu\n", __func__,
+		    lp->space_used, lp->space_used + space,
+		    lp->nodes_used, lp->nodes_used + nodes);
+
+		/* actually allocate */
+		lp->space_used += space;
+		lp->nodes_used += nodes;
+	} else {
+		VPSFSDEBUG("%s: DENIED allocation\n", __func__);
+	}
+
+	/* XXX unlock */
+
+	vpsfs_sched_sync(mount);
+
+	return (0);
+}
+
+int
+vpsfs_limit_free(struct vpsfs_mount *mount, size_t space, size_t nodes)
+{
+	struct vpsfs_limits *lp;
+
+	lp = mount->vpsfsm_limits;
+
+	/* XXX lock */
+
+	VPSFSDEBUG("%s: space_used: %zu -> %zu    nodes_used: %zu -> %zu\n",
+		__func__,
+		lp->space_used, lp->space_used - space,
+		lp->nodes_used, lp->nodes_used - nodes);
+
+	lp->space_used -= space;
+	lp->nodes_used -= nodes;
+
+	/* XXX unlock */
+
+	vpsfs_sched_sync(mount);
+
+	return (0);
+}
+
+int
+vpsfs_write_usage(struct vpsfs_mount *mount, struct vpsfs_limits *limits)
+{
+	struct nameidata nd;
+	struct iovec aiov[1];
+	struct uio auio;
+	struct thread *td;
+	struct vnode *vp2;
+	struct vnode *vp;
+	struct mount *mp;
+	char *filename;
+	char *retbuf;
+	char *buf;
+	int error;
+	int flags;
+
+	VPSFSDEBUG("%s: mount=%p limits=%p\n", __func__, mount, limits);
+
+	error = 0;
+	td = curthread;
+	vp = VPSFSVPTOLOWERVP(mount->vpsfsm_rootvp);
+	vref(vp);
+
+	/* determine pathname of quota file */
+
+	filename = malloc(MAXPATHLEN, M_TEMP, M_WAITOK | M_ZERO);
+
+	buf = malloc(MAXPATHLEN, M_TEMP, M_WAITOK | M_ZERO);
+	retbuf = "-";
+
+	error = vn_fullpath1(td, vp, td->td_proc->p_fd->fd_rdir, buf,
+	    &retbuf, MAXPATHLEN);
+	if (error) {
+		VPSFSDEBUG("%s: vn_fullpath1(): error=%d\n",
+		    __func__, error);
+		goto out;
+	}
+
+	VPSFSDEBUG("%s: fullpath of lower fs root vnode relative to "
+	    "processes rootdir is [%s]\n", __func__, retbuf);
+	snprintf(filename, MAXPATHLEN, "%s/%s", retbuf, "vpsfs_usage");
+	VPSFSDEBUG("%s: filename [%s]\n", __func__, filename);
+
+	/* now open/create file */
+	NDINIT(&nd, LOOKUP, NOFOLLOW, UIO_SYSSPACE, filename, td);
+	flags = FWRITE | O_NOFOLLOW | O_CREAT;
+	error = vn_open(&nd, &flags, 0, NULL);
+	if (error) {
+		VPSFSDEBUG("%s: vn_open(): error=%d\n", __func__, error);
+		goto out;
+	}
+	NDFREE(&nd, NDF_ONLY_PNBUF);
+	vp2 = nd.ni_vp;
+	vref(vp2);
+	VOP_UNLOCK(vp2, 0);
+
+	/* write information to file */
+
+	auio.uio_iov = &aiov[0];
+	auio.uio_offset = 0;
+	auio.uio_segflg = UIO_SYSSPACE;
+	auio.uio_rw = UIO_WRITE;
+	aiov[0].iov_base = (caddr_t)limits;
+	aiov[0].iov_len = sizeof(*limits);
+	auio.uio_resid = sizeof(*limits);
+	auio.uio_iovcnt = 1;
+	auio.uio_td = td;
+
+	crhold(td->td_ucred);
+	vn_start_write(vp2, &mp, V_WAIT);
+	vn_lock(vp2, LK_EXCLUSIVE | LK_RETRY);
+	error = VOP_WRITE(vp2, &auio, IO_UNIT | IO_SYNC, td->td_ucred);
+	VOP_UNLOCK(vp2, 0);
+	vn_finished_write(mp);
+	(void) vn_close(vp2, FWRITE, td->td_ucred, td);
+	crfree(td->td_ucred);
+	vrele(vp2);
+	if (error) {
+		VPSFSDEBUG("%s: VOP_WRITE(): error=%d\n", __func__, error);
+		goto out;
+	}
+
+	VPSFSDEBUG("%s: usage: space=%zu nodes=%zu\n",
+		__func__, limits->space_used, limits->nodes_used);
+
+  out:
+	free(buf, M_TEMP);
+	free(filename, M_TEMP);
+
+	vrele(vp);
+
+	return (error);
+}
+
+/* Read usage information from disk. */
+int
+vpsfs_read_usage(struct vpsfs_mount *mount, struct vpsfs_limits *limits)
+{
+	struct nameidata nd;
+	struct iovec aiov[1];
+	struct uio auio;
+	struct thread *td;
+	struct vnode *vp2;
+	struct vnode *vp;
+	char *filename;
+	char *retbuf;
+	char *buf;
+	int needs_recalc;
+	int error;
+	int flags;
+
+	VPSFSDEBUG("%s: mount=%p limits=%p\n", __func__, mount, limits);
+
+	error = 0;
+	needs_recalc = 0;
+	td = curthread;
+	vp = VPSFSVPTOLOWERVP(mount->vpsfsm_rootvp);
+	vref(vp);
+
+	/* determine pathname of quota file */
+
+	filename = malloc(MAXPATHLEN, M_TEMP, M_WAITOK | M_ZERO);
+
+	buf = malloc(MAXPATHLEN, M_TEMP, M_WAITOK | M_ZERO);
+	retbuf = "-";
+
+	error = vn_fullpath1(td, vp, td->td_proc->p_fd->fd_rdir, buf,
+	    &retbuf, MAXPATHLEN);
+	if (error) {
+		VPSFSDEBUG("%s: vn_fullpath1(): error=%d\n",
+		    __func__, error);
+		goto out;
+	}
+
+	VPSFSDEBUG("%s: fullpath of lower fs root vnode relative to "
+	    "processes rootdir is [%s]\n", __func__, retbuf);
+	snprintf(filename, MAXPATHLEN, "%s/%s", retbuf, "vpsfs_usage");
+	VPSFSDEBUG("%s: filename [%s]\n", __func__, filename);
+
+	/* now open file */
+	NDINIT(&nd, LOOKUP, NOFOLLOW, UIO_SYSSPACE, filename, td);
+	flags = FREAD | O_NOFOLLOW;
+	error = vn_open(&nd, &flags, 0, NULL);
+	if (error == ENOENT) {
+		VPSFSDEBUG("%s: file [%s] doesn't exist, recalculating!\n",
+			__func__, filename);
+		needs_recalc = 1;
+		goto out;
+	} else if (error != 0) {
+		VPSFSDEBUG("%s: vn_open(): error=%d\n", __func__, error);
+		goto out;
+	}
+	NDFREE(&nd, NDF_ONLY_PNBUF);
+	vp2 = nd.ni_vp;
+	vref(vp2);
+	VOP_UNLOCK(vp2, 0);
+
+	/* read information from file */
+
+	auio.uio_iov = &aiov[0];
+	auio.uio_offset = 0;
+	auio.uio_segflg = UIO_SYSSPACE;
+	auio.uio_rw = UIO_READ;
+	aiov[0].iov_base = (caddr_t)limits;
+	aiov[0].iov_len = sizeof(*limits);
+	auio.uio_resid = sizeof(*limits);
+	auio.uio_iovcnt = 1;
+	auio.uio_td = td;
+
+	crhold(td->td_ucred);
+	vn_lock(vp2, LK_EXCLUSIVE | LK_RETRY);
+	error = VOP_READ(vp2, &auio, IO_UNIT | IO_SYNC, td->td_ucred);
+	VOP_UNLOCK(vp2, 0);
+	(void) vn_close(vp2, FREAD, td->td_ucred, td);
+	crfree(td->td_ucred);
+	vrele(vp2);
+	if (error) {
+		VPSFSDEBUG("%s: VOP_READ(): error=%d\n", __func__, error);
+		goto out;
+	}
+
+  out:
+	free(buf, M_TEMP);
+	free(filename, M_TEMP);
+
+	vrele(vp);
+
+	if (needs_recalc)
+		error = vpsfs_calcusage(mount, limits);
+
+	VPSFSDEBUG("%s: usage: space=%zu nodes=%zu\n",
+		__func__, limits->space_used, limits->nodes_used);
+
+	return (error);
+}
+
+int
+vpsfs_calcusage_path(const char *path, struct vpsfs_limits *limits)
+{
+	struct nameidata nd;
+	struct thread *td;
+	struct mount *mp;
+	int error;
+
+	td = curthread;
+
+	NDINIT(&nd, LOOKUP, FOLLOW | LOCKLEAF | AUDITVNODE1, UIO_SYSSPACE,
+	    path, td);
+	if ((error = namei(&nd)))
+		return (error);
+	NDFREE(&nd, NDF_ONLY_PNBUF);
+	mp = nd.ni_vp->v_mount;
+	vfs_ref(mp);
+	vput(nd.ni_vp);
+
+	if (vpsfs_mount_is_vpsfs(mp) == 0) {
+		error = EINVAL;
+		goto fail;
+	}
+
+	error = vpsfs_calcusage(MOUNTTOVPSFSMOUNT(mp), limits);
+
+  fail:
+	vfs_rel(mp);
+
+	return (error);
+}
+
+int
+vpsfs_calcusage(struct vpsfs_mount *mount, struct vpsfs_limits *limits)
+{
+	struct thread *td = curthread;
+	//struct vpsfs_limits *limits;
+	struct vnode *lrootvp;
+	struct vnode *vp;
+	struct vattr va;
+	int dirbuflen;
+	int error = 0;
+
+	VPSFSDEBUG("%s: mount=%p\n", __func__, mount);
+
+	//limits = malloc(sizeof(*limits), M_TEMP, M_WAITOK | M_ZERO);
+
+	vp = lrootvp = VPSFSVPTOLOWERVP(mount->vpsfsm_rootvp);
+	VOP_LOCK(lrootvp, LK_SHARED | LK_RETRY);
+
+	error = VOP_GETATTR(lrootvp, &va, td->td_ucred);
+	if (error) {
+		//free(limits, M_TEMP);
+		return (error);
+	}
+
+	dirbuflen = DEV_BSIZE;
+	if (dirbuflen < va.va_blocksize)
+		dirbuflen = va.va_blocksize;
+
+	error = vpsfs_readdir(td, lrootvp, dirbuflen, limits,
+	    vpsfs_calcvnode);
+
+	VOP_UNLOCK(lrootvp, 0);
+
+	VPSFSDEBUG("%s: limits: space_used=%zu nodes_used=%zu\n",
+		__func__, limits->space_used, limits->nodes_used);
+
+	if (mount->vpsfsm_limits != limits)
+		memcpy(mount->vpsfsm_limits, limits, sizeof(*limits));
+
+	error = vpsfs_write_usage(mount, limits);
+
+	//free(limits, M_TEMP);
+
+	return (error);
+}
+
+static void
+vpsfs_calcvnode(struct vnode *vp, struct vpsfs_limits *limits,
+    struct thread *td)
+{
+	struct stat *sb;
+	int error;
+
+	if (vp->v_type != VREG)
+		return;
+
+	sb = malloc(sizeof(*sb), M_TEMP, M_WAITOK | M_ZERO);
+
+	error = vn_stat(vp, sb, td->td_ucred, td->td_ucred, td);
+	if (error) {
+		VPSFSDEBUG("%s: vn_stat() error=%d\n",
+			__func__, error);
+		goto out;
+	}
+
+	/* multiple links are counted only as (size / link count) */
+
+	limits->space_used += sb->st_size / sb->st_nlink;
+	limits->nodes_used += 1;
+
+ out:
+	free(sb, M_TEMP);
+	return;
+}
+
+/*
+ * XXX Better perform it without recursing functions !
+ */
+
+static int
+vpsfs_readdir(struct thread *td, struct vnode *vp, int dirbuflen,
+    struct vpsfs_limits *limits,
+    void (*cbfunc)(struct vnode *, struct vpsfs_limits *, struct thread *))
+{
+	struct componentname *cnp;
+	struct dirent *dp;
+	struct vnode *vp2;
+	char *dirbuf;
+	char *cpos = NULL;
+	off_t off;
+	int eofflag;
+	int len;
+	int error = 0;
+
+	//VPSFSDEBUG("%s: vp=%p\n", __func__, vp);
+	dirbuf = (char *)malloc(dirbuflen, M_TEMP, M_WAITOK);
+
+	/* Walk directory tree ... */
+	off = 0;
+	len = 0;
+	do {
+		error = get_next_dirent(vp, &dp, dirbuf, dirbuflen, &off,
+					&cpos, &len, &eofflag, td);
+		if (error) {
+			VPSFSDEBUG("%s: get_next_dirent() error=%d\n",
+				__func__, error);
+			goto out;
+		}
+
+		/*
+		VPSFSDEBUG("%s: dp=%p dp->d_type=%d dp->d_name=[%s]\n",
+			__func__, dp, dp->d_type, dp->d_name);
+		*/
+
+		if (dp->d_type == DT_DIR &&
+		    (strcmp(dp->d_name, ".")==0 ||
+		    strcmp(dp->d_name, "..")==0))
+			continue;
+
+		cnp = malloc(sizeof(*cnp), M_TEMP, M_WAITOK | M_ZERO);
+		cnp->cn_thread = td;
+		cnp->cn_cred = td->td_ucred;
+		cnp->cn_lkflags = LK_SHARED;
+		cnp->cn_nameiop = LOOKUP;
+		cnp->cn_pnbuf = dp->d_name;
+		cnp->cn_consume = strlen(dp->d_name);
+		cnp->cn_nameptr = dp->d_name;
+		cnp->cn_namelen = strlen(dp->d_name);
+
+		error = VOP_LOOKUP(vp, &vp2, cnp);
+		free(cnp, M_TEMP);
+		if (error) {
+			VPSFSDEBUG("%s: VOP_LOOKUP() error=%d\n",
+				__func__, error);
+			goto out;
+		}
+
+		cbfunc(vp2, limits, td);
+
+		if (dp->d_type == DT_DIR &&
+		    strcmp(dp->d_name, ".") &&
+		    strcmp(dp->d_name, "..")) {
+
+			if (vp2->v_mount != vp->v_mount) {
+				VPSFSDEBUG("%s: vp=%p vp2=%p have different"
+				    " mounts\n", __func__, vp, vp2);
+				goto next;
+			}
+
+			error = vpsfs_readdir(td, vp2, dirbuflen, limits,
+			    cbfunc);
+			if (error) {
+				VPSFSDEBUG("%s: vpsfs_readdir() error=%d\n",
+					__func__, error);
+				vput(vp2);
+				goto out;
+			}
+		}
+
+	  next:
+		vput(vp2);
+
+	} while (len > 0 || !eofflag);
+
+ out:
+	free(dirbuf, M_TEMP);
+	return (error);
+}
+
+/* copied from kern/vfs_default.c */
+static int
+get_next_dirent(struct vnode *vp, struct dirent **dpp, char *dirbuf,
+		int dirbuflen, off_t *off, char **cpos, int *len,
+		int *eofflag, struct thread *td)
+{
+	int error, reclen;
+	struct uio uio;
+	struct iovec iov;
+	struct dirent *dp;
+
+	KASSERT(VOP_ISLOCKED(vp), ("vp %p is not locked", vp));
+	KASSERT(vp->v_type == VDIR, ("vp %p is not a directory", vp));
+
+	if (*len == 0) {
+		iov.iov_base = dirbuf;
+		iov.iov_len = dirbuflen;
+
+		uio.uio_iov = &iov;
+		uio.uio_iovcnt = 1;
+		uio.uio_offset = *off;
+		uio.uio_resid = dirbuflen;
+		uio.uio_segflg = UIO_SYSSPACE;
+		uio.uio_rw = UIO_READ;
+		uio.uio_td = td;
+
+		*eofflag = 0;
+
+#ifdef MAC
+		error = mac_vnode_check_readdir(td->td_ucred, vp);
+		if (error == 0)
+#endif
+			error = VOP_READDIR(vp, &uio, td->td_ucred, eofflag,
+				NULL, NULL);
+		if (error)
+			return (error);
+
+		*off = uio.uio_offset;
+
+		*cpos = dirbuf;
+		*len = (dirbuflen - uio.uio_resid);
+	}
+
+	dp = (struct dirent *)(*cpos);
+	reclen = dp->d_reclen;
+	*dpp = dp;
+
+	/* check for malformed directory.. */
+	if (reclen < DIRENT_MINSIZE)
+		return (EINVAL);
+
+	*cpos += reclen;
+	*len -= reclen;
+
+	return (0);
+}
+
+#endif /* VPS */
+
+/* EOF */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/fs/vpsfs/vpsfs_subr.c head/sys/fs/vpsfs/vpsfs_subr.c
--- clean-head/sys/fs/vpsfs/vpsfs_subr.c	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/fs/vpsfs/vpsfs_subr.c	2013-06-24 14:20:41.000000000 +0200
@@ -0,0 +1,346 @@
+/*-
+ * Copyright (c) 1992, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * This code is derived from software donated to Berkeley by
+ * Jan-Simon Pendry.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)vpsfs_subr.c	8.7 (Berkeley) 5/14/95
+ *
+ * $FreeBSD: head/sys/fs/vpsfs/vpsfs_subr.c 250505 2013-05-11 11:17:44Z kib $
+ */
+
+#ifdef VPS
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/kernel.h>
+#include <sys/lock.h>
+#include <sys/mutex.h>
+#include <sys/malloc.h>
+#include <sys/mount.h>
+#include <sys/proc.h>
+#include <sys/vnode.h>
+#include <sys/taskqueue.h>
+
+#include <vps/vps_account.h>
+
+#include <fs/vpsfs/vpsfs.h>
+
+/*
+ * Null layer cache:
+ * Each cache entry holds a reference to the lower vnode
+ * along with a pointer to the alias vnode.  When an
+ * entry is added the lower vnode is VREF'd.  When the
+ * alias is removed the lower vnode is vrele'd.
+ */
+
+#define	VPSFS_NHASH(vp) \
+    (&vpsfs_node_hashtbl[vfs_hash_index(vp) & vpsfs_hash_mask])
+
+static LIST_HEAD(vpsfs_node_hashhead, vpsfs_node) *vpsfs_node_hashtbl;
+static struct mtx vpsfs_hashmtx;
+static u_long vpsfs_hash_mask;
+
+static MALLOC_DEFINE(M_VPSFSHASH, "vpsfs_hash", "VPSFS hash table");
+MALLOC_DEFINE(M_VPSFSNODE, "vpsfs_node", "VPSFS vnode private part");
+
+static struct vnode * vpsfs_hashins(struct mount *, struct vpsfs_node *);
+
+static const char *vpsfs_tag = "vpsfs";
+
+/*
+ * Initialise cache headers
+ */
+int
+vpsfs_init(vfsp)
+	struct vfsconf *vfsp;
+{
+
+	vpsfs_node_hashtbl = hashinit(desiredvnodes, M_VPSFSHASH,
+	    &vpsfs_hash_mask);
+	mtx_init(&vpsfs_hashmtx, "vpsfshs", NULL, MTX_DEF);
+
+	vps_func->vpsfs_calcusage_path = vpsfs_calcusage_path;
+	vps_func->vpsfs_nodeget = vpsfs_nodeget;
+	vps_func->vpsfs_tag = vpsfs_tag;
+
+	return (0);
+}
+
+int
+vpsfs_uninit(vfsp)
+	struct vfsconf *vfsp;
+{
+
+	vps_func->vpsfs_calcusage_path = NULL;
+	vps_func->vpsfs_nodeget = NULL;
+	vps_func->vpsfs_tag = NULL;
+
+	mtx_destroy(&vpsfs_hashmtx);
+	hashdestroy(vpsfs_node_hashtbl, M_VPSFSHASH, vpsfs_hash_mask);
+	return (0);
+}
+
+/*
+ * Return a VREF'ed alias for lower vnode if already exists, else 0.
+ * Lower vnode should be locked on entry and will be left locked on exit.
+ */
+struct vnode *
+vpsfs_hashget(mp, lowervp)
+	struct mount *mp;
+	struct vnode *lowervp;
+{
+	struct vpsfs_node_hashhead *hd;
+	struct vpsfs_node *a;
+	struct vnode *vp;
+
+	ASSERT_VOP_LOCKED(lowervp, "vpsfs_hashget");
+
+	/*
+	 * Find hash base, and then search the (two-way) linked
+	 * list looking for a vpsfs_node structure which is referencing
+	 * the lower vnode.  If found, the increment the vpsfs_node
+	 * reference count (but NOT the lower vnode's VREF counter).
+	 */
+	hd = VPSFS_NHASH(lowervp);
+	mtx_lock(&vpsfs_hashmtx);
+	LIST_FOREACH(a, hd, vpsfs_hash) {
+		if (a->vpsfs_lowervp == lowervp &&
+		    VPSFSTOV(a)->v_mount == mp) {
+			/*
+			 * Since we have the lower node locked the vpsfs
+			 * node can not be in the process of recycling.  If
+			 * it had been recycled before we grabed the lower
+			 * lock it would not have been found on the hash.
+			 */
+			vp = VPSFSTOV(a);
+			vref(vp);
+			mtx_unlock(&vpsfs_hashmtx);
+			return (vp);
+		}
+	}
+	mtx_unlock(&vpsfs_hashmtx);
+	return (NULLVP);
+}
+
+/*
+ * Act like vpsfs_hashget, but add passed vpsfs_node to hash if no existing
+ * node found.
+ */
+static struct vnode *
+vpsfs_hashins(mp, xp)
+	struct mount *mp;
+	struct vpsfs_node *xp;
+{
+	struct vpsfs_node_hashhead *hd;
+	struct vpsfs_node *oxp;
+	struct vnode *ovp;
+
+	hd = VPSFS_NHASH(xp->vpsfs_lowervp);
+	mtx_lock(&vpsfs_hashmtx);
+	LIST_FOREACH(oxp, hd, vpsfs_hash) {
+		if (oxp->vpsfs_lowervp == xp->vpsfs_lowervp &&
+		    VPSFSTOV(oxp)->v_mount == mp) {
+			/*
+			 * See vpsfs_hashget for a description of this
+			 * operation.
+			 */
+			ovp = VPSFSTOV(oxp);
+			vref(ovp);
+			mtx_unlock(&vpsfs_hashmtx);
+			return (ovp);
+		}
+	}
+	LIST_INSERT_HEAD(hd, xp, vpsfs_hash);
+	mtx_unlock(&vpsfs_hashmtx);
+	return (NULLVP);
+}
+
+static void
+vpsfs_destroy_proto(struct vnode *vp, void *xp)
+{
+
+	lockmgr(&vp->v_lock, LK_EXCLUSIVE, NULL);
+	VI_LOCK(vp);
+	vp->v_data = NULL;
+	vp->v_vnlock = &vp->v_lock;
+	vp->v_op = &dead_vnodeops;
+	VI_UNLOCK(vp);
+	vgone(vp);
+	vput(vp);
+	free(xp, M_VPSFSNODE);
+}
+
+static void
+vpsfs_insmntque_dtr(struct vnode *vp, void *xp)
+{
+
+	vput(((struct vpsfs_node *)xp)->vpsfs_lowervp);
+	vpsfs_destroy_proto(vp, xp);
+}
+
+/*
+ * Make a new or get existing vpsfs node.
+ * Vp is the alias vnode, lowervp is the lower vnode.
+ * 
+ * The lowervp assumed to be locked and having "spare" reference.
+ * This routine * vrele lowervp if vpsfs node was taken from hash.
+ * Otherwise it "transfers" * the caller's "spare" reference to
+ * created vpsfs vnode.
+ */
+int
+vpsfs_nodeget(mp, lowervp, vpp)
+	struct mount *mp;
+	struct vnode *lowervp;
+	struct vnode **vpp;
+{
+	struct vpsfs_node *xp;
+	struct vnode *vp;
+	int error;
+
+	ASSERT_VOP_LOCKED(lowervp, "lowervp");
+	KASSERT(lowervp->v_usecount >= 1,
+	    ("Unreferenced vnode %p", lowervp));
+
+	/* Lookup the hash firstly. */
+	*vpp = vpsfs_hashget(mp, lowervp);
+	if (*vpp != NULL) {
+		vrele(lowervp);
+		return (0);
+	}
+
+	/*
+	 * The insmntque1() call below requires the exclusive lock on
+	 * the vpsfs vnode.  Upgrade the lock now if hash failed to
+	 * provide ready to use vnode.
+	 */
+	if (VOP_ISLOCKED(lowervp) != LK_EXCLUSIVE) {
+		KASSERT((MOUNTTOVPSFSMOUNT(mp)->vpsfsm_flags &
+		    VPSFSM_CACHE) != 0,
+		    ("lowervp %p is not excl locked and cache is disabled",
+		    lowervp));
+		vn_lock(lowervp, LK_UPGRADE | LK_RETRY);
+		if ((lowervp->v_iflag & VI_DOOMED) != 0) {
+			vput(lowervp);
+			return (ENOENT);
+		}
+	}
+
+	/*
+	 * We do not serialize vnode creation, instead we will check for
+	 * duplicates later, when adding new vnode to hash.
+	 * Note that duplicate can only appear in hash if the lowervp is
+	 * locked LK_SHARED.
+	 */
+	xp = malloc(sizeof(struct vpsfs_node), M_VPSFSNODE, M_WAITOK);
+
+	error = getnewvnode(vpsfs_tag, mp, &vpsfs_vnodeops, &vp);
+	if (error) {
+		vput(lowervp);
+		free(xp, M_VPSFSNODE);
+		return (error);
+	}
+
+	xp->vpsfs_vnode = vp;
+	xp->vpsfs_lowervp = lowervp;
+	xp->vpsfs_flags = 0;
+	vp->v_type = lowervp->v_type;
+	vp->v_data = xp;
+	vp->v_vnlock = lowervp->v_vnlock;
+	error = insmntque1(vp, mp, vpsfs_insmntque_dtr, xp);
+	if (error != 0)
+		return (error);
+	/*
+	 * Atomically insert our new node into the hash or vget existing 
+	 * if someone else has beaten us to it.
+	 */
+	*vpp = vpsfs_hashins(mp, xp);
+	if (*vpp != NULL) {
+		vrele(lowervp);
+		vpsfs_destroy_proto(vp, xp);
+		return (0);
+	}
+	*vpp = vp;
+
+	return (0);
+}
+
+/*
+ * Remove node from hash.
+ */
+void
+vpsfs_hashrem(xp)
+	struct vpsfs_node *xp;
+{
+
+	mtx_lock(&vpsfs_hashmtx);
+	LIST_REMOVE(xp, vpsfs_hash);
+	mtx_unlock(&vpsfs_hashmtx);
+}
+
+#ifdef DIAGNOSTIC
+
+struct vnode *
+vpsfs_checkvp(vp, fil, lno)
+	struct vnode *vp;
+	char *fil;
+	int lno;
+{
+	struct vpsfs_node *a = VTOVPSFS(vp);
+
+#ifdef notyet
+	/*
+	 * Can't do this check because vop_reclaim runs
+	 * with a funny vop vector.
+	 */
+	if (vp->v_op != vpsfs_vnodeop_p) {
+		printf ("vpsfs_checkvp: on non-vpsfs-node\n");
+		panic("vpsfs_checkvp");
+	}
+#endif
+	if (a->vpsfs_lowervp == NULLVP) {
+		/* Should never happen */
+		panic("vpsfs_checkvp %p", vp);
+	}
+	VI_LOCK_FLAGS(a->vpsfs_lowervp, MTX_DUPOK);
+	if (a->vpsfs_lowervp->v_usecount < 1)
+		panic ("vpsfs with unref'ed lowervp, vp %p lvp %p",
+		    vp, a->vpsfs_lowervp);
+	VI_UNLOCK(a->vpsfs_lowervp);
+#ifdef notyet
+	printf("vpsfs %x/%d -> %x/%d [%s, %d]\n",
+		VPSFSTOV(a), vrefcnt(VPSFSTOV(a)),
+		a->vpsfs_lowervp, vrefcnt(a->vpsfs_lowervp),
+		fil, lno);
+#endif
+	return (a->vpsfs_lowervp);
+}
+#endif
+
+#endif /* VPS */
+
